
// Prototypes

module IN2 (A, Q);
  input A;
  output Q;
endmodule

module dc_a2ii_a2ii (r1, r2, a1, a2, r, a);
  input r1;
  input r2;
  input a1;
  input a2;
  output r;
  output a;
endmodule

module dc_a2ic2ii_c2a2iia2ii (r1, r2, r3, a1, a2, a3, a4, r, a);
  input r1;
  input r2;
  input r3;
  input a1;
  input a2;
  input a3;
  input a4;
  output r;
  output a;
endmodule

module ff_i_i (s1, r1, p, n);
  input s1;
  input r1;
  output p;
  output n;
endmodule

module ff_a2ii_a7iiiiiii (s1, s2, r1, r2, r3, r4, r5, r6, r7, p, n);
  input s1;
  input s2;
  input r1;
  input r2;
  input r3;
  input r4;
  input r5;
  input r6;
  input r7;
  output p;
  output n;
endmodule

// Main part

module _ (tst_p02_p13, tst_p02_p03, tst_p08_p12, tst_p08_p09, tst_p12_p00, tst_p13_p04, tst_p09_p02, tst_p03_p08, tst_p04_p08, tst_p00_p02, a_1, b_1, r_1, s_1);
  input tst_p02_p13;
  input tst_p02_p03;
  input tst_p08_p12;
  input tst_p08_p09;
  input tst_p12_p00;
  input tst_p13_p04;
  input tst_p09_p02;
  input tst_p03_p08;
  input tst_p04_p08;
  input tst_p00_p02;
  input a_1;
  input b_1;
  output r_1;
  output s_1;
  wire a_0;
  wire b_0;
  wire r_0;
  wire s_0;
  wire p00_req;
  wire p00_ack;
  wire p02_req;
  wire p02_ack;
  wire p03_req;
  wire p03_ack;
  wire p04_req;
  wire p04_ack;
  wire p08_req;
  wire p08_ack;
  wire p09_req;
  wire p09_ack;
  wire p12_req;
  wire p12_ack;
  wire p13_req;
  wire p13_ack;
  
  IN2 inv_a (a_1, a_0);
  IN2 inv_b (b_1, b_0);
  
  dc_a2ii_a2ii p00 (s_1, p12_req, p02_ack, tst_p00_p02, p00_req, p00_ack);
  dc_a2ic2ii_c2a2iia2ii p02 (s_0, p00_req, p09_req, p03_ack, tst_p02_p03, p13_ack, tst_p02_p13, p02_req, p02_ack);
  dc_a2ii_a2ii p03 (b_0, p02_req, p08_ack, tst_p03_p08, p03_req, p03_ack);
  dc_a2ii_a2ii p04 (s_1, p13_req, p08_ack, tst_p04_p08, p04_req, p04_ack);
  dc_a2ic2ii_c2a2iia2ii p08 (s_0, p04_req, p03_req, p09_ack, tst_p08_p09, p12_ack, tst_p08_p12, p08_req, p08_ack);
  dc_a2ii_a2ii p09 (b_0, p08_req, p02_ack, tst_p09_p02, p09_req, p09_ack);
  dc_a2ii_a2ii p12 (b_0, p08_req, p00_ack, tst_p12_p00, p12_req, p12_ack);
  dc_a2ii_a2ii p13 (b_0, p02_req, p04_ack, tst_p13_p04, p13_req, p13_ack);
  
  ff_i_i r (p03_ack, p09_req, r_1, r_0);
  ff_a2ii_a7iiiiiii s (p12_ack, p13_ack, p00_req, p04_req, p03_req, p09_req, b_1, a_0, a_1, s_1, s_0);
  
endmodule
