// Prototypes

module IN2 (A, Q);
  input A;
  output Q;
endmodule

module dc_a2ic2ii_a2ii (r1, r2, r3, a1, a2, r, a);
  input r1;
  input r2;
  input r3;
  input a1;
  input a2;
  output r;
  output a;
endmodule

module dc_a2ii_c2a2iia2ii (r1, r2, a1, a2, a3, a4, r, a);
  input r1;
  input r2;
  input a1;
  input a2;
  input a3;
  input a4;
  output r;
  output a;
endmodule

module dc_a2ii_a2ii (r1, r2, a1, a2, r, a);
  input r1;
  input r2;
  input a1;
  input a2;
  output r;
  output a;
endmodule

module ff_o2a5iiiiia2ii_o2a2iia2ii (s1, s2, s3, s4, s5, s6, s7, r1, r2, r3, r4, p, n);
  input s1;
  input s2;
  input s3;
  input s4;
  input s5;
  input s6;
  input s7;
  input r1;
  input r2;
  input r3;
  input r4;
  output p;
  output n;
endmodule

module ff_o2ii_o2ia4iiii (s1, s2, r1, r2, r3, r4, r5, p, n);
  input s1;
  input s2;
  input r1;
  input r2;
  input r3;
  input r4;
  input r5;
  output p;
  output n;
endmodule

module ff_a6iiiiii_a3iii (s1, s2, s3, s4, s5, s6, r1, r2, r3, p, n);
  input s1;
  input s2;
  input s3;
  input s4;
  input s5;
  input s6;
  input r1;
  input r2;
  input r3;
  output p;
  output n;
endmodule

module ff_i_i (s1, r1, p, n);
  input s1;
  input r1;
  output p;
  output n;
endmodule

module ff_a4iiii_a3iii (s1, s2, s3, s4, r1, r2, r3, p, n);
  input s1;
  input s2;
  input s3;
  input s4;
  input r1;
  input r2;
  input r3;
  output p;
  output n;
endmodule

// Main part

module _ (tst_p12_p01, tst_p09_p01, tst_p08_p12, tst_p05_p09, tst_p05_p08, tst_p01_p05, a_1, b_1, c_1, d_1, x_1);
  input tst_p12_p01;
  input tst_p09_p01;
  input tst_p08_p12;
  input tst_p05_p09;
  input tst_p05_p08;
  input tst_p01_p05;
  output a_1;
  output b_1;
  output c_1;
  output d_1;
  output x_1;
  wire a_0;
  wire b_0;
  wire c_0;
  wire d_0;
  wire x_0;
  wire p01_req;
  wire p01_ack;
  wire p05_req;
  wire p05_ack;
  wire p08_req;
  wire p08_ack;
  wire p09_req;
  wire p09_ack;
  wire p12_req;
  wire p12_ack;
  
  
  dc_a2ic2ii_a2ii p01 (c_1, p09_req, p12_req, p05_ack, tst_p01_p05, p01_req, p01_ack);
  dc_a2ii_c2a2iia2ii p05 (x_1, p01_req, p08_ack, tst_p05_p08, p09_ack, tst_p05_p09, p05_req, p05_ack);
  dc_a2ii_a2ii p08 (c_0, p05_req, p12_ack, tst_p08_p12, p08_req, p08_ack);
  dc_a2ii_a2ii p09 (c_0, p05_req, p01_ack, tst_p09_p01, p09_req, p09_ack);
  dc_a2ii_a2ii p12 (a_0, p08_req, p01_ack, tst_p12_p01, p12_req, p12_ack);
  
  ff_o2a5iiiiia2ii_o2a2iia2ii a (p09_ack, p12_ack, d_1, b_1, x_1, p05_ack, b_1, p08_req, b_1, p01_req, b_1, a_1, a_0);
  ff_o2ii_o2ia4iiii b (p08_ack, p01_ack, p05_req, p09_req, p12_req, d_0, x_0, b_1, b_0);
  ff_a6iiiiii_a3iii c (p09_ack, p12_ack, d_1, b_1, a_0, x_1, p05_req, b_0, a_1, c_1, c_0);
  ff_i_i d (p01_ack, p09_req, d_1, d_0);
  ff_a4iiii_a3iii x (p01_ack, b_0, a_1, d_0, p09_req, p12_req, d_0, x_1, x_0);
  
endmodule
