// Prototypes

module IN2 (A, Q);
  input A;
  output Q;
endmodule

module dc_a2ii_c2a2iia2ii (r1, r2, a1, a2, a3, a4, r, a);
  input r1;
  input r2;
  input a1;
  input a2;
  input a3;
  input a4;
  output r;
  output a;
endmodule

module dc_a2ic2ii_a2ii (r1, r2, r3, a1, a2, r, a);
  input r1;
  input r2;
  input r3;
  input a1;
  input a2;
  output r;
  output a;
endmodule

module dc_a2ic2ii_c2a2iia2ii (r1, r2, r3, a1, a2, a3, a4, r, a);
  input r1;
  input r2;
  input r3;
  input a1;
  input a2;
  input a3;
  input a4;
  output r;
  output a;
endmodule

module ff_o2a3iiia3iii_o2a6iiiiiia3iii (s1, s2, s3, s4, s5, s6, r1, r2, r3, r4, r5, r6, r7, r8, r9, p, n);
  input s1;
  input s2;
  input s3;
  input s4;
  input s5;
  input s6;
  input r1;
  input r2;
  input r3;
  input r4;
  input r5;
  input r6;
  input r7;
  input r8;
  input r9;
  output p;
  output n;
endmodule

// Main part

module _ (tst_p12_p15_01, tst_p12_p15_00, tst_p07_01_p15_01, tst_p07_01_p15_00, tst_p07_00_p12, tst_p03_p07_01, tst_p03_p07_00, tst_p04_p07_01, tst_p04_p07_00, tst_p15_01_p04, tst_p15_00_p03, a_1, c_1, d_1, x_1, b_1);
  input tst_p12_p15_01;
  input tst_p12_p15_00;
  input tst_p07_01_p15_01;
  input tst_p07_01_p15_00;
  input tst_p07_00_p12;
  input tst_p03_p07_01;
  input tst_p03_p07_00;
  input tst_p04_p07_01;
  input tst_p04_p07_00;
  input tst_p15_01_p04;
  input tst_p15_00_p03;
  input a_1;
  input c_1;
  input d_1;
  input x_1;
  output b_1;
  wire a_0;
  wire b_0;
  wire c_0;
  wire d_0;
  wire x_0;
  wire p03_req;
  wire p03_ack;
  wire p04_req;
  wire p04_ack;
  wire p07_00_req;
  wire p07_00_ack;
  wire p07_01_req;
  wire p07_01_ack;
  wire p12_req;
  wire p12_ack;
  wire p15_00_req;
  wire p15_00_ack;
  wire p15_01_req;
  wire p15_01_ack;
  
  IN2 inv_a (a_1, a_0);
  IN2 inv_c (c_1, c_0);
  IN2 inv_d (d_1, d_0);
  IN2 inv_x (x_1, x_0);
  
  dc_a2ii_c2a2iia2ii p03 (d_1, p15_00_req, p07_00_ack, tst_p03_p07_00, p07_01_ack, tst_p03_p07_01, p03_req, p03_ack);
  dc_a2ii_c2a2iia2ii p04 (a_0, p15_01_req, p07_00_ack, tst_p04_p07_00, p07_01_ack, tst_p04_p07_01, p04_req, p04_ack);
  dc_a2ic2ii_a2ii p07_00 (a_1, p04_req, p03_req, p12_ack, tst_p07_00_p12, p07_00_req, p07_00_ack);
  dc_a2ic2ii_c2a2iia2ii p07_01 (a_1, p04_req, p03_req, p15_00_ack, tst_p07_01_p15_00, p15_01_ack, tst_p07_01_p15_01, p07_01_req, p07_01_ack);
  dc_a2ii_c2a2iia2ii p12 (a_0, p07_00_req, p15_00_ack, tst_p12_p15_00, p15_01_ack, tst_p12_p15_01, p12_req, p12_ack);
  dc_a2ic2ii_a2ii p15_00 (a_1, p07_01_req, p12_req, p03_ack, tst_p15_00_p03, p15_00_req, p15_00_ack);
  dc_a2ic2ii_a2ii p15_01 (a_1, p07_01_req, p12_req, p04_ack, tst_p15_01_p04, p15_01_req, p15_01_ack);
  
  ff_o2a3iiia3iii_o2a6iiiiiia3iii b (p07_00_ack, p07_01_ack, c_1, p15_00_ack, p15_01_ack, c_0, p07_00_req, p07_01_req, p12_req, c_0, x_0, d_0, p04_req, p03_req, x_1, b_1, b_0);
  
endmodule
