// Prototypes

module IN2 (A, Q);
  input A;
  output Q;
endmodule

module dc_a2ii_c2a2iia2ii (r1, r2, a1, a2, a3, a4, r, a);
  input r1;
  input r2;
  input a1;
  input a2;
  input a3;
  input a4;
  output r;
  output a;
endmodule

module dc_a2ic2ii_a2ii (r1, r2, r3, a1, a2, r, a);
  input r1;
  input r2;
  input r3;
  input a1;
  input a2;
  output r;
  output a;
endmodule

module dc_a2ic2ii_c2a2iia2ii (r1, r2, r3, a1, a2, a3, a4, r, a);
  input r1;
  input r2;
  input r3;
  input a1;
  input a2;
  input a3;
  input a4;
  output r;
  output a;
endmodule

module ff_a3iii_a3iii (s1, s2, s3, r1, r2, r3, p, n);
  input s1;
  input s2;
  input s3;
  input r1;
  input r2;
  input r3;
  output p;
  output n;
endmodule

// Main part

module _ (tst_p10_p14_01, tst_p10_p14_00, tst_p06_01_p14_01, tst_p06_01_p14_00, tst_p06_00_p10, tst_p03_p06_01, tst_p03_p06_00, tst_p02_p06_01, tst_p02_p06_00, tst_p14_01_p03, tst_p14_00_p02, a_1, b_1, d_1, x_1, c_1);
  input tst_p10_p14_01;
  input tst_p10_p14_00;
  input tst_p06_01_p14_01;
  input tst_p06_01_p14_00;
  input tst_p06_00_p10;
  input tst_p03_p06_01;
  input tst_p03_p06_00;
  input tst_p02_p06_01;
  input tst_p02_p06_00;
  input tst_p14_01_p03;
  input tst_p14_00_p02;
  input a_1;
  input b_1;
  input d_1;
  input x_1;
  output c_1;
  wire a_0;
  wire b_0;
  wire c_0;
  wire d_0;
  wire x_0;
  wire p02_req;
  wire p02_ack;
  wire p03_req;
  wire p03_ack;
  wire p06_00_req;
  wire p06_00_ack;
  wire p06_01_req;
  wire p06_01_ack;
  wire p10_req;
  wire p10_ack;
  wire p14_00_req;
  wire p14_00_ack;
  wire p14_01_req;
  wire p14_01_ack;
  
  IN2 inv_a (a_1, a_0);
  IN2 inv_b (b_1, b_0);
  IN2 inv_d (d_1, d_0);
  IN2 inv_x (x_1, x_0);
  
  dc_a2ii_c2a2iia2ii p02 (b_1, p14_00_req, p06_00_ack, tst_p02_p06_00, p06_01_ack, tst_p02_p06_01, p02_req, p02_ack);
  dc_a2ii_c2a2iia2ii p03 (d_1, p14_01_req, p06_00_ack, tst_p03_p06_00, p06_01_ack, tst_p03_p06_01, p03_req, p03_ack);
  dc_a2ic2ii_a2ii p06_00 (b_0, p02_req, p03_req, p10_ack, tst_p06_00_p10, p06_00_req, p06_00_ack);
  dc_a2ic2ii_c2a2iia2ii p06_01 (b_0, p02_req, p03_req, p14_00_ack, tst_p06_01_p14_00, p14_01_ack, tst_p06_01_p14_01, p06_01_req, p06_01_ack);
  dc_a2ii_c2a2iia2ii p10 (b_1, p06_00_req, p14_00_ack, tst_p10_p14_00, p14_01_ack, tst_p10_p14_01, p10_req, p10_ack);
  dc_a2ic2ii_a2ii p14_00 (b_0, p06_01_req, p10_req, p02_ack, tst_p14_00_p02, p14_00_req, p14_00_ack);
  dc_a2ic2ii_a2ii p14_01 (b_0, p06_01_req, p10_req, p03_ack, tst_p14_01_p03, p14_01_req, p14_01_ack);
  
  ff_a3iii_a3iii c (p14_00_ack, p14_01_ack, a_0, p06_00_req, p06_01_req, a_1, c_1, c_0);
  
endmodule
