// Prototypes

module IN2 (A, Q);
  input A;
  output Q;
endmodule

module dc_a2ii_c2a2iia2ii (r1, r2, a1, a2, a3, a4, r, a);
  input r1;
  input r2;
  input a1;
  input a2;
  input a3;
  input a4;
  output r;
  output a;
endmodule

module dc_a2ic2ii_a2ii (r1, r2, r3, a1, a2, r, a);
  input r1;
  input r2;
  input r3;
  input a1;
  input a2;
  output r;
  output a;
endmodule

module dc_a2ic2ii_c2a2iia2ii (r1, r2, r3, a1, a2, a3, a4, r, a);
  input r1;
  input r2;
  input r3;
  input a1;
  input a2;
  input a3;
  input a4;
  output r;
  output a;
endmodule

module ff_a4iiii_a7iiiiiii (s1, s2, s3, s4, r1, r2, r3, r4, r5, r6, r7, p, n);
  input s1;
  input s2;
  input s3;
  input s4;
  input r1;
  input r2;
  input r3;
  input r4;
  input r5;
  input r6;
  input r7;
  output p;
  output n;
endmodule

// Main part

module _ (tst_p14_01_p01, tst_p10_p14_01, tst_p10_p14_00, tst_p06_01_p14_01, tst_p06_01_p14_00, tst_p06_00_p10, tst_p02_p06_00, tst_p02_p06_01, tst_p01_p06_00, tst_p01_p06_01, tst_p14_00_p02, a_1, b_1, c_1, d_1, x_1);
  input tst_p14_01_p01;
  input tst_p10_p14_01;
  input tst_p10_p14_00;
  input tst_p06_01_p14_01;
  input tst_p06_01_p14_00;
  input tst_p06_00_p10;
  input tst_p02_p06_00;
  input tst_p02_p06_01;
  input tst_p01_p06_00;
  input tst_p01_p06_01;
  input tst_p14_00_p02;
  input a_1;
  input b_1;
  input c_1;
  input d_1;
  output x_1;
  wire a_0;
  wire b_0;
  wire c_0;
  wire d_0;
  wire x_0;
  wire p01_req;
  wire p01_ack;
  wire p02_req;
  wire p02_ack;
  wire p06_00_req;
  wire p06_00_ack;
  wire p06_01_req;
  wire p06_01_ack;
  wire p10_req;
  wire p10_ack;
  wire p14_00_req;
  wire p14_00_ack;
  wire p14_01_req;
  wire p14_01_ack;
  
  IN2 inv_a (a_1, a_0);
  IN2 inv_b (b_1, b_0);
  IN2 inv_c (c_1, c_0);
  IN2 inv_d (d_1, d_0);
  
  dc_a2ii_c2a2iia2ii p01 (c_1, p14_01_req, p06_01_ack, tst_p01_p06_01, p06_00_ack, tst_p01_p06_00, p01_req, p01_ack);
  dc_a2ii_c2a2iia2ii p02 (b_1, p14_00_req, p06_01_ack, tst_p02_p06_01, p06_00_ack, tst_p02_p06_00, p02_req, p02_ack);
  dc_a2ic2ii_a2ii p06_00 (b_0, p01_req, p02_req, p10_ack, tst_p06_00_p10, p06_00_req, p06_00_ack);
  dc_a2ic2ii_c2a2iia2ii p06_01 (b_0, p01_req, p02_req, p14_00_ack, tst_p06_01_p14_00, p14_01_ack, tst_p06_01_p14_01, p06_01_req, p06_01_ack);
  dc_a2ii_c2a2iia2ii p10 (b_1, p06_00_req, p14_00_ack, tst_p10_p14_00, p14_01_ack, tst_p10_p14_01, p10_req, p10_ack);
  dc_a2ic2ii_a2ii p14_00 (b_0, p06_01_req, p10_req, p02_ack, tst_p14_00_p02, p14_00_req, p14_00_ack);
  dc_a2ic2ii_a2ii p14_01 (b_0, p06_01_req, p10_req, p01_ack, tst_p14_01_p01, p14_01_req, p14_01_ack);
  
  ff_a4iiii_a7iiiiiii x (p01_ack, p02_ack, d_0, a_1, p06_00_req, p06_01_req, p10_req, a_1, d_0, a_0, c_0, x_1, x_0);
  
endmodule
