// Prototypes

module IN2 (A, Q);
  input A;
  output Q;
endmodule

module dc_a2ii_a2ii (r1, r2, a1, a2, r, a);
  input r1;
  input r2;
  input a1;
  input a2;
  output r;
  output a;
endmodule

module ff_a2ii_a2ii (s1, s2, r1, r2, p, n);
  input s1;
  input s2;
  input r1;
  input r2;
  output p;
  output n;
endmodule

module ff_a2ii_a4iiii (s1, s2, r1, r2, r3, r4, p, n);
  input s1;
  input s2;
  input r1;
  input r2;
  input r3;
  input r4;
  output p;
  output n;
endmodule

// Main part

module _ (tst_p29_p33, tst_p27_p29, tst_p25_p27, tst_p23_p25, tst_p21_p23, tst_p19_p21, tst_p17_p19, tst_p15_p17, tst_p13_p15, tst_p11_p13, tst_p09_p11, tst_p07_p09, tst_p05_p07, tst_p03_p05, tst_p01_p03, tst_p33_p01, a0_1, b1_1, c1_1, d1_1, e1_1, f1_1, g1_1, j1_1, k1_1, a1_1, b0_1, c0_1, d0_1, e0_1, f0_1, g0_1, j0_1, k0_1);
  input tst_p29_p33;
  input tst_p27_p29;
  input tst_p25_p27;
  input tst_p23_p25;
  input tst_p21_p23;
  input tst_p19_p21;
  input tst_p17_p19;
  input tst_p15_p17;
  input tst_p13_p15;
  input tst_p11_p13;
  input tst_p09_p11;
  input tst_p07_p09;
  input tst_p05_p07;
  input tst_p03_p05;
  input tst_p01_p03;
  input tst_p33_p01;
  input a0_1;
  input b1_1;
  input c1_1;
  input d1_1;
  input e1_1;
  input f1_1;
  input g1_1;
  input j1_1;
  input k1_1;
  output a1_1;
  output b0_1;
  output c0_1;
  output d0_1;
  output e0_1;
  output f0_1;
  output g0_1;
  output j0_1;
  output k0_1;
  wire a0_0;
  wire a1_0;
  wire b0_0;
  wire b1_0;
  wire c0_0;
  wire c1_0;
  wire d0_0;
  wire d1_0;
  wire e0_0;
  wire e1_0;
  wire f0_0;
  wire f1_0;
  wire g0_0;
  wire g1_0;
  wire j0_0;
  wire j1_0;
  wire k0_0;
  wire k1_0;
  wire p01_req;
  wire p01_ack;
  wire p03_req;
  wire p03_ack;
  wire p05_req;
  wire p05_ack;
  wire p07_req;
  wire p07_ack;
  wire p09_req;
  wire p09_ack;
  wire p11_req;
  wire p11_ack;
  wire p13_req;
  wire p13_ack;
  wire p15_req;
  wire p15_ack;
  wire p17_req;
  wire p17_ack;
  wire p19_req;
  wire p19_ack;
  wire p21_req;
  wire p21_ack;
  wire p23_req;
  wire p23_ack;
  wire p25_req;
  wire p25_ack;
  wire p27_req;
  wire p27_ack;
  wire p29_req;
  wire p29_ack;
  wire p33_req;
  wire p33_ack;
  
  IN2 inv_a0 (a0_1, a0_0);
  IN2 inv_b1 (b1_1, b1_0);
  IN2 inv_c1 (c1_1, c1_0);
  IN2 inv_d1 (d1_1, d1_0);
  IN2 inv_e1 (e1_1, e1_0);
  IN2 inv_f1 (f1_1, f1_0);
  IN2 inv_g1 (g1_1, g1_0);
  IN2 inv_j1 (j1_1, j1_0);
  IN2 inv_k1 (k1_1, k1_0);
  
  dc_a2ii_a2ii p01 (b0_1, p33_req, p03_ack, tst_p01_p03, p01_req, p01_ack);
  dc_a2ii_a2ii p03 (b0_0, p01_req, p05_ack, tst_p03_p05, p03_req, p03_ack);
  dc_a2ii_a2ii p05 (c0_1, p03_req, p07_ack, tst_p05_p07, p05_req, p05_ack);
  dc_a2ii_a2ii p07 (c0_0, p05_req, p09_ack, tst_p07_p09, p07_req, p07_ack);
  dc_a2ii_a2ii p09 (d0_1, p07_req, p11_ack, tst_p09_p11, p09_req, p09_ack);
  dc_a2ii_a2ii p11 (d0_0, p09_req, p13_ack, tst_p11_p13, p11_req, p11_ack);
  dc_a2ii_a2ii p13 (e0_1, p11_req, p15_ack, tst_p13_p15, p13_req, p13_ack);
  dc_a2ii_a2ii p15 (e0_0, p13_req, p17_ack, tst_p15_p17, p15_req, p15_ack);
  dc_a2ii_a2ii p17 (f0_1, p15_req, p19_ack, tst_p17_p19, p17_req, p17_ack);
  dc_a2ii_a2ii p19 (f0_0, p17_req, p21_ack, tst_p19_p21, p19_req, p19_ack);
  dc_a2ii_a2ii p21 (g0_1, p19_req, p23_ack, tst_p21_p23, p21_req, p21_ack);
  dc_a2ii_a2ii p23 (g0_0, p21_req, p25_ack, tst_p23_p25, p23_req, p23_ack);
  dc_a2ii_a2ii p25 (j0_1, p23_req, p27_ack, tst_p25_p27, p25_req, p25_ack);
  dc_a2ii_a2ii p27 (j0_0, p25_req, p29_ack, tst_p27_p29, p27_req, p27_ack);
  dc_a2ii_a2ii p29 (k0_1, p27_req, p33_ack, tst_p29_p33, p29_req, p29_ack);
  dc_a2ii_a2ii p33 (k0_0, p29_req, p01_ack, tst_p33_p01, p33_req, p33_ack);
  
  ff_a2ii_a2ii a1 (p29_ack, k1_0, p33_req, k1_0, a1_1, a1_0);
  ff_a2ii_a2ii b0 (p33_ack, a0_0, p01_req, b1_1, b0_1, b0_0);
  ff_a2ii_a2ii c0 (p03_ack, b1_1, p05_req, c1_1, c0_1, c0_0);
  ff_a2ii_a2ii d0 (p07_ack, c1_1, p09_req, d1_1, d0_1, d0_0);
  ff_a2ii_a2ii e0 (p11_ack, d1_1, p13_req, e1_1, e0_1, e0_0);
  ff_a2ii_a2ii f0 (p15_ack, e1_1, p17_req, f1_1, f0_1, f0_0);
  ff_a2ii_a2ii g0 (p19_ack, f1_1, p21_req, g1_1, g0_1, g0_0);
  ff_a2ii_a2ii j0 (p23_ack, g1_1, p25_req, j1_1, j0_1, j0_0);
  ff_a2ii_a4iiii k0 (p27_ack, j1_1, p29_req, k1_1, a0_0, a1_1, k0_1, k0_0);
  
endmodule
