// Prototypes

module IN2 (A, Q);
  input A;
  output Q;
endmodule

module dc_a2ii_a2ii (r1, r2, a1, a2, r, a);
  input r1;
  input r2;
  input a1;
  input a2;
  output r;
  output a;
endmodule

module ff_o3a2iia2iia2ii_o3a2iia2iia2ii (s1, s2, s3, s4, s5, s6, r1, r2, r3, r4, r5, r6, p, n);
  input s1;
  input s2;
  input s3;
  input s4;
  input s5;
  input s6;
  input r1;
  input r2;
  input r3;
  input r4;
  input r5;
  input r6;
  output p;
  output n;
endmodule

module ff_a2ii_a2ii (s1, s2, r1, r2, p, n);
  input s1;
  input s2;
  input r1;
  input r2;
  output p;
  output n;
endmodule

// Main part

module _ (tst_p13_p15, tst_p11_p13, tst_p09_p11, tst_p07_p09, tst_p05_p07, tst_p03_p05, tst_p01_p03, tst_p15_p01, a_1, b_1, c_1);
  input tst_p13_p15;
  input tst_p11_p13;
  input tst_p09_p11;
  input tst_p07_p09;
  input tst_p05_p07;
  input tst_p03_p05;
  input tst_p01_p03;
  input tst_p15_p01;
  input a_1;
  output b_1;
  output c_1;
  wire a_0;
  wire b_0;
  wire c_0;
  wire p01_req;
  wire p01_ack;
  wire p03_req;
  wire p03_ack;
  wire p05_req;
  wire p05_ack;
  wire p07_req;
  wire p07_ack;
  wire p09_req;
  wire p09_ack;
  wire p11_req;
  wire p11_ack;
  wire p13_req;
  wire p13_ack;
  wire p15_req;
  wire p15_ack;
  
  IN2 inv_a (a_1, a_0);
  
  dc_a2ii_a2ii p01 (b_1, p15_req, p03_ack, tst_p01_p03, p01_req, p01_ack);
  dc_a2ii_a2ii p03 (b_0, p01_req, p05_ack, tst_p03_p05, p03_req, p03_ack);
  dc_a2ii_a2ii p05 (b_1, p03_req, p07_ack, tst_p05_p07, p05_req, p05_ack);
  dc_a2ii_a2ii p07 (b_0, p05_req, p09_ack, tst_p07_p09, p07_req, p07_ack);
  dc_a2ii_a2ii p09 (b_1, p07_req, p11_ack, tst_p09_p11, p09_req, p09_ack);
  dc_a2ii_a2ii p11 (b_0, p09_req, p13_ack, tst_p11_p13, p11_req, p11_ack);
  dc_a2ii_a2ii p13 (c_1, p11_req, p15_ack, tst_p13_p15, p13_req, p13_ack);
  dc_a2ii_a2ii p15 (c_0, p13_req, p01_ack, tst_p15_p01, p15_req, p15_ack);
  
  ff_o3a2iia2iia2ii_o3a2iia2iia2ii b (p07_ack, a_0, p03_ack, a_0, p15_ack, a_0, p09_req, a_0, p05_req, a_0, p01_req, a_0, b_1, b_0);
  ff_a2ii_a2ii c (p11_ack, a_0, p13_req, a_0, c_1, c_0);
  
endmodule
