// Prototypes

module IN2 (A, Q);
  input A;
  output Q;
endmodule

module dc_a2ii_a2ii (r1, r2, a1, a2, r, a);
  input r1;
  input r2;
  input a1;
  input a2;
  output r;
  output a;
endmodule

module ff_a2ii_a2ii (s1, s2, r1, r2, p, n);
  input s1;
  input s2;
  input r1;
  input r2;
  output p;
  output n;
endmodule

module ff_a2ii_a4iiii (s1, s2, r1, r2, r3, r4, p, n);
  input s1;
  input s2;
  input r1;
  input r2;
  input r3;
  input r4;
  output p;
  output n;
endmodule

// Main part

module _ (tst_p13_p17, tst_p11_p13, tst_p09_p11, tst_p07_p09, tst_p05_p07, tst_p03_p05, tst_p01_p03, tst_p17_p01, a0_1, b1_1, c1_1, d1_1, e1_1, a1_1, b0_1, c0_1, d0_1, e0_1);
  input tst_p13_p17;
  input tst_p11_p13;
  input tst_p09_p11;
  input tst_p07_p09;
  input tst_p05_p07;
  input tst_p03_p05;
  input tst_p01_p03;
  input tst_p17_p01;
  input a0_1;
  input b1_1;
  input c1_1;
  input d1_1;
  input e1_1;
  output a1_1;
  output b0_1;
  output c0_1;
  output d0_1;
  output e0_1;
  wire a0_0;
  wire a1_0;
  wire b0_0;
  wire b1_0;
  wire c0_0;
  wire c1_0;
  wire d0_0;
  wire d1_0;
  wire e0_0;
  wire e1_0;
  wire p01_req;
  wire p01_ack;
  wire p03_req;
  wire p03_ack;
  wire p05_req;
  wire p05_ack;
  wire p07_req;
  wire p07_ack;
  wire p09_req;
  wire p09_ack;
  wire p11_req;
  wire p11_ack;
  wire p13_req;
  wire p13_ack;
  wire p17_req;
  wire p17_ack;
  
  IN2 inv_a0 (a0_1, a0_0);
  IN2 inv_b1 (b1_1, b1_0);
  IN2 inv_c1 (c1_1, c1_0);
  IN2 inv_d1 (d1_1, d1_0);
  IN2 inv_e1 (e1_1, e1_0);
  
  dc_a2ii_a2ii p01 (b0_1, p17_req, p03_ack, tst_p01_p03, p01_req, p01_ack);
  dc_a2ii_a2ii p03 (b0_0, p01_req, p05_ack, tst_p03_p05, p03_req, p03_ack);
  dc_a2ii_a2ii p05 (c0_1, p03_req, p07_ack, tst_p05_p07, p05_req, p05_ack);
  dc_a2ii_a2ii p07 (c0_0, p05_req, p09_ack, tst_p07_p09, p07_req, p07_ack);
  dc_a2ii_a2ii p09 (d0_1, p07_req, p11_ack, tst_p09_p11, p09_req, p09_ack);
  dc_a2ii_a2ii p11 (d0_0, p09_req, p13_ack, tst_p11_p13, p11_req, p11_ack);
  dc_a2ii_a2ii p13 (e0_1, p11_req, p17_ack, tst_p13_p17, p13_req, p13_ack);
  dc_a2ii_a2ii p17 (e0_0, p13_req, p01_ack, tst_p17_p01, p17_req, p17_ack);
  
  ff_a2ii_a2ii a1 (p13_ack, e1_0, p17_req, e1_0, a1_1, a1_0);
  ff_a2ii_a2ii b0 (p17_ack, a0_0, p01_req, b1_1, b0_1, b0_0);
  ff_a2ii_a2ii c0 (p03_ack, b1_1, p05_req, c1_1, c0_1, c0_0);
  ff_a2ii_a2ii d0 (p07_ack, c1_1, p09_req, d1_1, d0_1, d0_0);
  ff_a2ii_a4iiii e0 (p11_ack, d1_1, p13_req, e1_1, a0_0, a1_1, e0_1, e0_0);
  
endmodule
